(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('@angular/platform-browser'), require('@angular/common'), require('rxjs'), require('rxjs/operators'), require('@nguniversal/express-engine/tokens'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('angular-wagtail', ['exports', '@angular/common/http', '@angular/core', '@angular/platform-browser', '@angular/common', 'rxjs', 'rxjs/operators', '@nguniversal/express-engine/tokens', '@angular/router'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-wagtail'] = {}, global.ng.common.http, global.ng.core, global.ng.platformBrowser, global.ng.common, global.rxjs, global.rxjs.operators, global.tokens, global.ng.router));
}(this, (function (exports, i1, i0, i3, common, rxjs, operators, tokens, i2) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var WAGTAIL_CONFIG = new i0.InjectionToken('Wagtail Config');

    var StatusCodeService = /** @class */ (function () {
        function StatusCodeService(_response) {
            this._response = _response;
        }
        StatusCodeService.prototype.setStatus = function (code, message) {
            if (this._response) {
                this._response.statusCode = code;
                this._response.statusMessage = message;
            }
        };
        StatusCodeService.prototype.redirect = function (url, isPermanant) {
            if (isPermanant === void 0) { isPermanant = true; }
            if (isPermanant) {
                this.setStatus(301, 'Moved Permanently');
            }
            else {
                this.setStatus(302, 'Found');
            }
            this._response.setHeader('Location', url);
        };
        return StatusCodeService;
    }());
    StatusCodeService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: StatusCodeService, deps: [{ token: tokens.RESPONSE, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    StatusCodeService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: StatusCodeService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: StatusCodeService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [tokens.RESPONSE]
                        }] }];
        } });

    var CMS_DOMAIN_KEY = i3.makeStateKey('Wagtail Domain');
    var CMS_SITE_ID_KEY = i3.makeStateKey('Wagtail Site ID');
    var WagtailService = /** @class */ (function () {
        function WagtailService(http, statusCodeService, state, title, meta, doc, config, platformId) {
            var _this = this;
            this.http = http;
            this.statusCodeService = statusCodeService;
            this.state = state;
            this.title = title;
            this.meta = meta;
            this.doc = doc;
            this.config = config;
            this.platformId = platformId;
            this.page = new rxjs.BehaviorSubject(null);
            this.currentPageComponent = this.page.pipe(operators.exhaustMap(function (page) {
                return _this.getComponentForPage(page);
            }));
        }
        /** Strip out query params and #anchor */
        WagtailService.prototype.sanitizePath = function (path) {
            return path.split('?')[0].split('#')[0];
        };
        WagtailService.prototype.getPageForUrl = function (url) {
            var _this = this;
            var _a;
            var pathname = this.sanitizePathname(url);
            var params = new URLSearchParams({ html_path: pathname });
            var siteId = this.getWagtailSiteID();
            if (siteId)
                params.set('site', siteId.toString());
            return this.http
                .get("" + this.getWagtailDomain() + ((_a = this.config.pagesApiPath) !== null && _a !== void 0 ? _a : '/api/v2/pages/detail_by_path/') + "?" + params.toString())
                .pipe(operators.tap(function (page) { return _this.setMeta(page); }), operators.catchError(function (err) {
                if (err instanceof i1.HttpErrorResponse && err.status === 404) {
                    return rxjs.of(null);
                }
                throw err;
            }));
        };
        /**
         * Get the Wagtail Domain
         * Set the env var CMS_DOMAIN in node to override the domain
         * Otherwise it will default to "" meaning the same domain angular runs in.
         */
        WagtailService.prototype.getWagtailDomain = function () {
            var cmsDomain = this.state.get(CMS_DOMAIN_KEY, '');
            if (cmsDomain) {
                return cmsDomain;
            }
            if (this.config.apiDomain) {
                cmsDomain = this.config.apiDomain;
            }
            else if (common.isPlatformServer(this.platformId)) {
                var envCmsDomain = process.env.CMS_DOMAIN;
                if (envCmsDomain) {
                    cmsDomain = envCmsDomain;
                }
            }
            this.state.set(CMS_DOMAIN_KEY, cmsDomain);
            return cmsDomain;
        };
        /** Get Wagtail Site ID which may be configured by a Node env var or from the module config  */
        WagtailService.prototype.getWagtailSiteID = function () {
            var cmsId = this.state.get(CMS_SITE_ID_KEY, null);
            if (typeof cmsId === 'number') {
                return cmsId;
            }
            if (this.config.siteId) {
                cmsId = this.config.siteId;
            }
            else if (common.isPlatformServer(this.platformId)) {
                var envcmsId = process.env.WAGTAIL_SITE_ID;
                if (envcmsId) {
                    cmsId = parseInt(envcmsId);
                }
            }
            this.state.set(CMS_SITE_ID_KEY, cmsId);
            return cmsId;
        };
        WagtailService.prototype.getRedirectForUrl = function (url) {
            var siteId = this.getWagtailSiteID();
            var params = Object.assign({ old_path: url }, (siteId && {
                site: siteId.toString(),
            }));
            return this.http.get(this.getWagtailDomain() + "/api/redirects/", { params: params });
        };
        WagtailService.prototype.getComponentForPage = function (page) {
            return __awaiter(this, void 0, void 0, function () {
                var route;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (page === null) {
                                return [2 /*return*/];
                            }
                            else if (page === '404') {
                                this.statusCodeService.setStatus(404, 'Not Found');
                                return [2 /*return*/, this.config.notFoundComponent];
                            }
                            route = this.config.pageTypes.find(function (route) { return route.type === page.meta.type; });
                            if (!route) {
                                return [2 /*return*/, this.config.notFoundComponent];
                            }
                            if (!('component' in route)) return [3 /*break*/, 1];
                            return [2 /*return*/, route.component];
                        case 1: return [4 /*yield*/, route.loadComponent()];
                        case 2: return [2 /*return*/, _b.sent()];
                    }
                });
            });
        };
        /** Support for wagtail-headless-preview API */
        WagtailService.prototype.getPreviewData = function (contentType, token) {
            var url = this.getWagtailDomain() + '/api/v2/page_preview/1/';
            var params = new i1.HttpParams({
                fromObject: {
                    content_type: contentType,
                    token: token,
                    format: 'json',
                },
            });
            return this.http.get(url, { params: params });
        };
        WagtailService.prototype.sanitizePathname = function (path) {
            return path.split(/[?#]/)[0];
        };
        /** Set title and description meta tag for SEO */
        WagtailService.prototype.setMeta = function (data) {
            if (data.meta.seo_title) {
                this.title.setTitle(data.meta.seo_title);
            }
            else {
                this.title.setTitle(data.title);
            }
            if (data.meta.search_description) {
                this.meta.addTag({
                    name: 'description',
                    content: data.meta.search_description,
                });
            }
            if (this.config.setCanonicalURL) {
                this.createLinkForCanonicalURL(data.meta.html_url);
            }
        };
        WagtailService.prototype.createLinkForCanonicalURL = function (url) {
            var link = this.doc.createElement('link');
            link.setAttribute('rel', 'canonical');
            this.doc.head.appendChild(link);
            link.setAttribute('href', url);
        };
        return WagtailService;
    }());
    WagtailService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailService, deps: [{ token: i1__namespace.HttpClient }, { token: StatusCodeService }, { token: i3__namespace.TransferState }, { token: i3__namespace.Title }, { token: i3__namespace.Meta }, { token: common.DOCUMENT }, { token: WAGTAIL_CONFIG }, { token: i0.PLATFORM_ID }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    WagtailService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () {
            return [{ type: i1__namespace.HttpClient }, { type: StatusCodeService }, { type: i3__namespace.TransferState }, { type: i3__namespace.Title }, { type: i3__namespace.Meta }, { type: Document, decorators: [{
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [WAGTAIL_CONFIG]
                        }] }, { type: Object, decorators: [{
                            type: i0.Inject,
                            args: [i0.PLATFORM_ID]
                        }] }];
        } });

    var WagtailComponent = /** @class */ (function () {
        function WagtailComponent(wagtail, cfr, injector) {
            this.wagtail = wagtail;
            this.cfr = cfr;
            this.injector = injector;
        }
        WagtailComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.wagtail.currentPageComponent.subscribe(function (component) {
                if (component) {
                    var factory = _this.cfr.resolveComponentFactory(component);
                    _this.outlet.clear();
                    _this.outlet.createComponent(factory, undefined, _this.injector);
                }
            });
        };
        return WagtailComponent;
    }());
    WagtailComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailComponent, deps: [{ token: WagtailService }, { token: i0__namespace.ComponentFactoryResolver }, { token: i0__namespace.Injector }], target: i0__namespace.ɵɵFactoryTarget.Component });
    WagtailComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.1", type: WagtailComponent, selector: "lib-angular-wagtail", viewQueries: [{ propertyName: "outlet", first: true, predicate: ["wagtailOutlet"], descendants: true, read: i0.ViewContainerRef }], ngImport: i0__namespace, template: "<ng-container #wagtailOutlet></ng-container>", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-angular-wagtail',
                        template: "<ng-container #wagtailOutlet></ng-container>",
                    }]
            }], ctorParameters: function () { return [{ type: WagtailService }, { type: i0__namespace.ComponentFactoryResolver }, { type: i0__namespace.Injector }]; }, propDecorators: {
            // @ts-ignore
            outlet: [{
                    type: i0.ViewChild,
                    args: ['wagtailOutlet', { read: i0.ViewContainerRef }]
                }]
        } });

    var GetPageDataResolverService = /** @class */ (function () {
        function GetPageDataResolverService(wagtail, router, platformId, statusCodeService) {
            this.wagtail = wagtail;
            this.router = router;
            this.platformId = platformId;
            this.statusCodeService = statusCodeService;
        }
        GetPageDataResolverService.prototype.resolve = function (route, state) {
            var _this = this;
            if (route.data.preview) {
                var contentType = route.queryParams.content_type;
                var token = route.queryParams.token;
                if (contentType && token) {
                    return this.wagtail.getPreviewData(contentType, token).pipe(operators.exhaustMap(function (page) {
                        if (page) {
                            return rxjs.from(_this.wagtail.getComponentForPage(page)).pipe(operators.map(function () {
                                _this.wagtail.page.next(page);
                                return page;
                            }));
                        }
                        return rxjs.EMPTY;
                    }));
                }
            }
            return this.wagtail.getPageForUrl(state.url).pipe(operators.exhaustMap(function (page) {
                if (page === null) {
                    return _this.wagtail.getRedirectForUrl(state.url).pipe(operators.exhaustMap(function (redirects) {
                        if (redirects.length > 0) {
                            _this.redirect(redirects[0]);
                            return rxjs.of(null);
                        }
                        _this.wagtail.page.next('404');
                        return rxjs.of('404');
                    }));
                }
                // We need to force any lazy loaded code to load in the resolver, but it should
                // return only the page data.
                return rxjs.from(_this.wagtail.getComponentForPage(page)).pipe(operators.map(function () {
                    _this.wagtail.page.next(page);
                    return page;
                }));
            }));
        };
        /**
         * On server, send redirect status code
         * On browser, change window.location
         */
        GetPageDataResolverService.prototype.redirect = function (redirect) {
            if (common.isPlatformServer(this.platformId)) {
                this.statusCodeService.redirect(redirect.link, redirect.is_permanent);
            }
            else {
                var path = redirect.link;
                if (path.startsWith('http')) {
                    if (window.location.href === path) {
                        console.warn('Refused to redirect to self');
                    }
                    else {
                        window.location.href = path;
                    }
                }
                else {
                    this.router.navigate([path]);
                }
            }
        };
        return GetPageDataResolverService;
    }());
    GetPageDataResolverService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: GetPageDataResolverService, deps: [{ token: WagtailService }, { token: i2__namespace.Router }, { token: i0.PLATFORM_ID }, { token: StatusCodeService }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    GetPageDataResolverService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: GetPageDataResolverService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: GetPageDataResolverService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () {
            return [{ type: WagtailService }, { type: i2__namespace.Router }, { type: Object, decorators: [{
                            type: i0.Inject,
                            args: [i0.PLATFORM_ID]
                        }] }, { type: StatusCodeService }];
        } });

    var WagtailModule = /** @class */ (function () {
        function WagtailModule() {
        }
        WagtailModule.forRoot = function (config) {
            return {
                ngModule: WagtailModule,
                providers: [
                    GetPageDataResolverService,
                    { provide: WAGTAIL_CONFIG, useValue: config },
                ],
            };
        };
        return WagtailModule;
    }());
    WagtailModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    WagtailModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailModule, declarations: [WagtailComponent], imports: [i1.HttpClientModule], exports: [WagtailComponent] });
    WagtailModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailModule, providers: [StatusCodeService], imports: [[i1.HttpClientModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.1", ngImport: i0__namespace, type: WagtailModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [WagtailComponent],
                        imports: [i1.HttpClientModule],
                        providers: [StatusCodeService],
                        exports: [WagtailComponent],
                    }]
            }] });

    /*
     * Public API Surface of angular-wagtail
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.GetPageDataResolverService = GetPageDataResolverService;
    exports.StatusCodeService = StatusCodeService;
    exports.WagtailComponent = WagtailComponent;
    exports.WagtailModule = WagtailModule;
    exports.WagtailService = WagtailService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-wagtail.umd.js.map
