import { Resolve, RouterStateSnapshot, ActivatedRouteSnapshot, Router } from '@angular/router';
import { WagtailRedirect } from './interfaces';
import { WagtailService } from './wagtail.service';
import { StatusCodeService } from './status-code.service';
import * as i0 from "@angular/core";
export declare class GetPageDataResolverService implements Resolve<unknown> {
    private wagtail;
    private router;
    private platformId;
    private statusCodeService;
    constructor(wagtail: WagtailService, router: Router, platformId: Object, statusCodeService: StatusCodeService);
    resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): import("rxjs").Observable<string | import("./interfaces").WagtailPageDetail | null>;
    /**
     * On server, send redirect status code
     * On browser, change window.location
     */
    redirect(redirect: WagtailRedirect): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GetPageDataResolverService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<GetPageDataResolverService>;
}
